clang-tools 10.0.0

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
clang::tidy::ClangTidyOptions Struct Reference

Contains options for clang-tidy. More...

`#include <ClangTidyOptions.h>`

Collaboration diagram for clang::tidy::ClangTidyOptions:
[legend]

## Public Types
typedef std::pair< std::string, std::string > | StringPair
typedef std::map< std::string, std::string > | OptionMap
typedef std::vector< std::string > | ArgList

## Public Member Functions
ClangTidyOptions | mergeWith (const ClangTidyOptions &Other) const
| Creates a new `ClangTidyOptions` instance combined from all fields of this instance overridden by the fields of `Other` that have a value. More...

## Static Public Member Functions
static ClangTidyOptions | getDefaults ()
| These options are used for all settings that haven't been overridden by the `OptionsProvider`. More...

## Public Attributes
llvm::Optional< std::string > | Checks
| Checks filter. More...
llvm::Optional< std::string > | WarningsAsErrors
| WarningsAsErrors filter. More...
llvm::Optional< std::string > | HeaderFilterRegex
| Output warnings from headers matching this filter. More...
llvm::Optional< bool > | SystemHeaders
| Output warnings from system headers matching `HeaderFilterRegex`. More...
llvm::Optional< std::string > | FormatStyle
| Format code around applied fixes with clang-format using this style. More...
llvm::Optional< std::string > | User
| Specifies the name or e-mail of the user running clang-tidy. More...
OptionMap | CheckOptions
| Key-value mapping used to store check-specific options. More...
llvm::Optional< ArgList > | ExtraArgs
| Add extra compilation arguments to the end of the list. More...
llvm::Optional< ArgList > | ExtraArgsBefore
| Add extra compilation arguments to the start of the list. More...

## Detailed Description

Contains options for clang-tidy.

These options may be read from configuration files, and may be different for different translation units.

Definition at line 50 of file ClangTidyOptions.h.

## Member Typedef Documentation

## ◆ ArgList

typedef std::vector<std::string> clang::tidy::ClangTidyOptions::ArgList

Definition at line 102 of file ClangTidyOptions.h.

## ◆ OptionMap

typedef std::map<std::string, std::string> clang::tidy::ClangTidyOptions::OptionMap

Definition at line 97 of file ClangTidyOptions.h.

## ◆ StringPair

typedef std::pair<std::string, std::string> clang::tidy::ClangTidyOptions::StringPair

Definition at line 96 of file ClangTidyOptions.h.

## Member Function Documentation

## ◆ getDefaults()

ClangTidyOptions clang::tidy::ClangTidyOptions::getDefaults | ( |  | ) |
| static

These options are used for all settings that haven't been overridden by the `OptionsProvider`.

Allow no checks and no headers by default. This method initializes check-specific options by calling `ClangTidyModule::getModuleOptions()` of each registered `ClangTidyModule`.

Definition at line 104 of file ClangTidyOptions.cpp.

References Checks, E, FormatStyle, HeaderFilterRegex, mergeWith(), SystemHeaders, User, and WarningsAsErrors.

Referenced by clang::tidy::ClangTidyContext::getOptionsForFile().

## ◆ mergeWith()

ClangTidyOptions clang::tidy::ClangTidyOptions::mergeWith | ( | const ClangTidyOptions & | Other | ) | const

Creates a new `ClangTidyOptions` instance combined from all fields of this instance overridden by the fields of `Other` that have a value.

Definition at line 142 of file ClangTidyOptions.cpp.

Referenced by getDefaults(), and clang::tidy::ClangTidyContext::getOptionsForFile().

## Member Data Documentation

## ◆ CheckOptions

OptionMap clang::tidy::ClangTidyOptions::CheckOptions

Key-value mapping used to store check-specific options.

Definition at line 100 of file ClangTidyOptions.h.

Referenced by llvm::yaml::MappingTraits< ClangTidyOptions >::mapping().

## ◆ Checks

llvm::Optional<std::string> clang::tidy::ClangTidyOptions::Checks

Checks filter.

Definition at line 64 of file ClangTidyOptions.h.

Referenced by clang::clangd::TestTU::build(), getDefaults(), llvm::yaml::MappingTraits< ClangTidyOptions >::mapping(), and clang::tidy::ClangTidyContext::setCurrentFile().

## ◆ ExtraArgs

llvm::Optional<ArgList> clang::tidy::ClangTidyOptions::ExtraArgs

Add extra compilation arguments to the end of the list.

Definition at line 105 of file ClangTidyOptions.h.

Referenced by llvm::yaml::MappingTraits< ClangTidyOptions >::mapping().

## ◆ ExtraArgsBefore

llvm::Optional<ArgList> clang::tidy::ClangTidyOptions::ExtraArgsBefore

Add extra compilation arguments to the start of the list.

Definition at line 108 of file ClangTidyOptions.h.

Referenced by llvm::yaml::MappingTraits< ClangTidyOptions >::mapping().

## ◆ FormatStyle

llvm::Optional<std::string> clang::tidy::ClangTidyOptions::FormatStyle

Format code around applied fixes with clang-format using this style.

Can be one of:

- 'none' - don't format code around applied fixes;
- 'llvm', 'google', 'mozilla' or other predefined clang-format style names;
- 'file' - use the .clang-format file in the closest parent directory of each source file;
- '{inline-formatting-style-in-yaml-format}'.

See clang-format documentation for more about configuring format style.

Definition at line 88 of file ClangTidyOptions.h.

Referenced by getDefaults(), and llvm::yaml::MappingTraits< ClangTidyOptions >::mapping().

## ◆ HeaderFilterRegex

llvm::Optional<std::string> clang::tidy::ClangTidyOptions::HeaderFilterRegex

Output warnings from headers matching this filter.

Warnings from main files will always be displayed.

Definition at line 71 of file ClangTidyOptions.h.

Referenced by getDefaults(), and llvm::yaml::MappingTraits< ClangTidyOptions >::mapping().

## ◆ SystemHeaders

llvm::Optional<bool> clang::tidy::ClangTidyOptions::SystemHeaders

Output warnings from system headers matching `HeaderFilterRegex`.

Definition at line 74 of file ClangTidyOptions.h.

Referenced by getDefaults().

## ◆ User

llvm::Optional<std::string> clang::tidy::ClangTidyOptions::User

Specifies the name or e-mail of the user running clang-tidy.

This option is used, for example, to place the correct user name in TODO() comments in the relevant check.

Definition at line 94 of file ClangTidyOptions.h.

Referenced by getDefaults(), and llvm::yaml::MappingTraits< ClangTidyOptions >::mapping().

## ◆ WarningsAsErrors

llvm::Optional<std::string> clang::tidy::ClangTidyOptions::WarningsAsErrors

WarningsAsErrors filter.

Definition at line 67 of file ClangTidyOptions.h.

Referenced by clang::clangd::TestTU::build(), getDefaults(), llvm::yaml::MappingTraits< ClangTidyOptions >::mapping(), and clang::tidy::ClangTidyContext::setCurrentFile().

The documentation for this struct was generated from the following files:

- ClangTidyOptions.h
- ClangTidyOptions.cpp